// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXC = 1000000000;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>("n");

	cout << n << "\n";
	int x = 0, y = 0;
	while (x == 0 && y == 0) {
		x = rnd.next(-1000, 1000);
		y = rnd.next(-1000, 1000);
	}

	set<int> used;
	for (int i = 0; i < n; ++i) {
		int k;
		do {
			k = rnd.next(-MAXC / 100, MAXC / 100);
		} while ((ll) k * x < -MAXC || (ll) k * x > MAXC || (ll) k * y < -MAXC || (ll) k * y > MAXC || used.count(k));
		used.insert(k);
		cout << k * x << " " << k * y << "\n";
	}

	return 0;
}