#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int MAXN[] = {10, 15, (int)1e5, (int)1e5, (int)1e5};
int MAXM[] = {100, 150, (int)1e6, (int)1e6, (int)1e6};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    auto gr = validator.group().empty() ? 0 : validator.group()[0] - '0';
    int n = inf.readInt(1, MAXN[gr], "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXM[gr], "m");
    inf.readEoln();
    int cnt = 0;
    for (int i = 0; i < n; i++) {
    	if (i)
    		inf.readSpace();
    	int x = inf.readInt((int)-1e9, (int)1e9, "a_i");
    	cnt += (x < 0);
    }
    ensuref(gr != 3 || cnt <= 10, "too many negative numbers");
    inf.readEoln();
    set<pair<int, int>> se;
    for (int i = 0; i < m; i++) {
    	int a = inf.readInt(1, n, "a");
    	inf.readSpace();
    	int delta = 10;
    	if (gr == 2)
    		delta = 1;
    	int b = inf.readInt(a + 1, min(n, a + delta), "b");
    	pair<int, int> p = {a, b};
    	ensuref(se.count(p) == 0, "Same pair");
    	se.insert(p);
    	inf.readEoln();
    }
    inf.readEof();
}