#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int n = atoi(argv[1]), k = atoi(argv[2]);
    long long lim = atoll(argv[3]);

    println(n);
    vector<long long> ax;
    long long minx = lim, maxx = -lim;
    for (int i = 0; i < n; i++) {
        long long a = rnd.next(-lim / 2, lim / 2);
        ax.push_back(a);
        minx = min(minx, a);
        maxx = max(maxx, a);
    }
    println(ax.begin(), ax.end());

    println(k);
    vector<long long> x;
    long long total = 0;
    for (int i = 0; i < k; i++) {
        long long xi = rnd.next(-lim - minx - total, lim - maxx - total);
        x.push_back(xi);
        total += xi;
    }
    println(x.begin(), x.end());

}