#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int limit = 20000;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n;
    cin >> n;
    vector<int> a(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());

    vector<long long> pref{0};
    for (unsigned int i = 0; i < n; i++) {
        pref.push_back(pref.back() + a[i]);
    }

    vector<long long> result(2 * limit + 1);
    unsigned int last = 0;
    result[0] = pref.back() + n * limit;
    for (unsigned int i = 0; i < n; i++) {
        while (last < a[i] + limit) {
            last++;
            result[last] = result[last - 1] - ((long long) n - 2 * i);
        }
        result[last] = pref.back() - 2 * pref[i + 1] - a[i] * ((long long) n - 2 * (i + 1));
    }
    while (last < result.size() - 1) {
        last++;
        result[last] = result[last - 1] + n;
    }

    unsigned int k;
    cin >> k;
    int total = 0;
    for (unsigned int i = 0; i < k; i++) {
        int x;
        cin >> x;
        total += x;

        cout << result[-total + limit] << '\n';
    }

}