rem   *** validation ***
call scripts\run-validator-tests.bat
call scripts\run-checker-tests.bat

rem    *** tests ***
md tests
call scripts\gen-input-via-stdout.bat "files\gen.exe 10 10" "tests\03" 3
call scripts\gen-input-via-stdout.bat "files\gen.exe 100 100" "tests\04" 4
call scripts\gen-input-via-stdout.bat "files\gen.exe 100 64" "tests\05" 5
call scripts\gen-input-via-stdout.bat "files\gen.exe 32 100" "tests\06" 6
call scripts\gen-input-via-stdout.bat "files\gen.exe 100 16" "tests\07" 7
call scripts\gen-input-via-stdout.bat "files\gen.exe 100 1" "tests\08" 8
call scripts\gen-input-via-stdout.bat "files\gen.exe 10 8" "tests\09" 9
call scripts\gen-input-via-stdout.bat "files\gen.exe 64 64" "tests\10" 10
call scripts\gen-input-via-stdout.bat "files\gen.exe 32 96" "tests\11" 11
call scripts\gen-input-via-stdout.bat "files\gen.exe 1 99" "tests\12" 12
call scripts\gen-input-via-stdout.bat "files\gen.exe 1 1" "tests\13" 13
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 128" "tests\14" 14
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 256" "tests\15" 15
call scripts\gen-input-via-stdout.bat "files\gen.exe 512 1000000000" "tests\16" 16
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 1024" "tests\17" 17
call scripts\gen-input-via-stdout.bat "files\gen.exe 2048 999999999" "tests\18" 18
call scripts\gen-input-via-stdout.bat "files\gen.exe 4096 900000000" "tests\19" 19
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 8192" "tests\20" 20
call scripts\gen-input-via-stdout.bat "files\gen.exe 16384 1000000000" "tests\21" 21
call scripts\gen-input-via-stdout.bat "files\gen.exe 1 65536" "tests\22" 22
call scripts\gen-input-via-stdout.bat "files\gen.exe 131072 900000000" "tests\23" 23
call scripts\gen-input-via-stdout.bat "files\gen.exe 262144 8192" "tests\24" 24
call scripts\gen-input-via-stdout.bat "files\gen.exe 524288 1000000000" "tests\25" 25
call scripts\gen-input-via-stdout.bat "files\gen.exe 1048576 65536" "tests\26" 26
call scripts\gen-input-via-stdout.bat "files\gen.exe 2097152 1000000000" "tests\27" 27
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 4194304" "tests\28" 28
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 8388608" "tests\29" 29
call scripts\gen-input-via-stdout.bat "files\gen.exe 16777216 1000000000" "tests\30" 30
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 33554432" "tests\31" 31
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 67108864" "tests\32" 32
call scripts\gen-input-via-stdout.bat "files\gen.exe 134217728 100000000" "tests\33" 33
call scripts\gen-input-via-stdout.bat "files\gen.exe 268435456 999999999" "tests\34" 34
call scripts\gen-input-via-stdout.bat "files\gen.exe 536870912 900000000" "tests\35" 35
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 1000000000" "tests\36" 36
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 900000000" "tests\37" 37
call scripts\gen-input-via-stdout.bat "files\gen.exe 999999999 1000000000" "tests\38" 38
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 805306368" "tests\39" 39
call scripts\gen-input-via-stdout.bat "files\gen.exe 671088640 999999999" "tests\40" 40
call scripts\gen-input-via-stdout.bat "files\gen.exe 234881024 900000000" "tests\41" 41
call scripts\gen-input-via-stdout.bat "files\gen.exe 1000000000 369098752" "tests\42" 42
call scripts\gen-input-via-stdout.bat "files\gen.exe 452984832 1000000000" "tests\43" 43
call scripts\gen-input-via-stdout.bat "files\gen.exe 968884224 65536" "tests\44" 44
call scripts\gen-input-via-stdout.bat "files\gen.exe 692060160 900000000" "tests\45" 45
call scripts\gen-input-via-stdout.bat "files\gen.exe 737624064 8192" "tests\46" 46
call scripts\gen-input-via-stdout.bat "files\gen.exe 896663552 1000000000" "tests\47" 47
call scripts\gen-input-via-stdout.bat "files\gen.exe 536870912 536870912" "tests\48" 48
call scripts\gen-answer.bat tests\01 tests\01.a "tests" "0"
call scripts\gen-answer.bat tests\02 tests\02.a "tests" "0"
call scripts\gen-answer.bat tests\03 tests\03.a "tests" "1"
call scripts\gen-answer.bat tests\04 tests\04.a "tests" "1"
call scripts\gen-answer.bat tests\05 tests\05.a "tests" "1"
call scripts\gen-answer.bat tests\06 tests\06.a "tests" "1"
call scripts\gen-answer.bat tests\07 tests\07.a "tests" "1"
call scripts\gen-answer.bat tests\08 tests\08.a "tests" "1"
call scripts\gen-answer.bat tests\09 tests\09.a "tests" "1"
call scripts\gen-answer.bat tests\10 tests\10.a "tests" "1"
call scripts\gen-answer.bat tests\11 tests\11.a "tests" "1"
call scripts\gen-answer.bat tests\12 tests\12.a "tests" "1"
call scripts\gen-answer.bat tests\13 tests\13.a "tests" "1"
call scripts\gen-answer.bat tests\14 tests\14.a "tests" "2"
call scripts\gen-answer.bat tests\15 tests\15.a "tests" "2"
call scripts\gen-answer.bat tests\16 tests\16.a "tests" "2"
call scripts\gen-answer.bat tests\17 tests\17.a "tests" "2"
call scripts\gen-answer.bat tests\18 tests\18.a "tests" "2"
call scripts\gen-answer.bat tests\19 tests\19.a "tests" "2"
call scripts\gen-answer.bat tests\20 tests\20.a "tests" "2"
call scripts\gen-answer.bat tests\21 tests\21.a "tests" "2"
call scripts\gen-answer.bat tests\22 tests\22.a "tests" "2"
call scripts\gen-answer.bat tests\23 tests\23.a "tests" "2"
call scripts\gen-answer.bat tests\24 tests\24.a "tests" "2"
call scripts\gen-answer.bat tests\25 tests\25.a "tests" "2"
call scripts\gen-answer.bat tests\26 tests\26.a "tests" "2"
call scripts\gen-answer.bat tests\27 tests\27.a "tests" "2"
call scripts\gen-answer.bat tests\28 tests\28.a "tests" "2"
call scripts\gen-answer.bat tests\29 tests\29.a "tests" "2"
call scripts\gen-answer.bat tests\30 tests\30.a "tests" "2"
call scripts\gen-answer.bat tests\31 tests\31.a "tests" "2"
call scripts\gen-answer.bat tests\32 tests\32.a "tests" "2"
call scripts\gen-answer.bat tests\33 tests\33.a "tests" "2"
call scripts\gen-answer.bat tests\34 tests\34.a "tests" "2"
call scripts\gen-answer.bat tests\35 tests\35.a "tests" "2"
call scripts\gen-answer.bat tests\36 tests\36.a "tests" "3"
call scripts\gen-answer.bat tests\37 tests\37.a "tests" "3"
call scripts\gen-answer.bat tests\38 tests\38.a "tests" "3"
call scripts\gen-answer.bat tests\39 tests\39.a "tests" "3"
call scripts\gen-answer.bat tests\40 tests\40.a "tests" "3"
call scripts\gen-answer.bat tests\41 tests\41.a "tests" "3"
call scripts\gen-answer.bat tests\42 tests\42.a "tests" "3"
call scripts\gen-answer.bat tests\43 tests\43.a "tests" "3"
call scripts\gen-answer.bat tests\44 tests\44.a "tests" "3"
call scripts\gen-answer.bat tests\45 tests\45.a "tests" "3"
call scripts\gen-answer.bat tests\46 tests\46.a "tests" "3"
call scripts\gen-answer.bat tests\47 tests\47.a "tests" "3"
call scripts\gen-answer.bat tests\48 tests\48.a "tests" "3"

