rem   *** validation ***
call scripts\run-validator-tests.bat
call scripts\run-checker-tests.bat

rem    *** tests ***
md tests
call scripts\gen-input-via-stdout.bat "files\gen_random.exe -n=1000 a" "tests\04" 4
call scripts\gen-input-via-stdout.bat "files\gen_random.exe -n=1000 b" "tests\05" 5
call scripts\gen-input-via-stdout.bat "files\gen_random.exe -n=1000 c" "tests\06" 6
call scripts\gen-input-via-stdout.bat "files\gen_line.exe -n=1000" "tests\07" 7
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=1000 a" "tests\08" 8
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=1000 b" "tests\09" 9
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=1000 c" "tests\10" 10
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=900 -mess_inside=100" "tests\11" 11
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=900 -special -mess_inside=100" "tests\12" 12
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=1000 -ro=500000000" "tests\13" 13
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=500 -ro=123456789 -i=500 -ri=123000000" "tests\14" 14
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=100 -ro=500000000 -i=899 -ri=490000000" "tests\15" 15
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=900 -ro=500000000 -mess_inside=100" "tests\16" 16
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=600 -ro=500000000 -special -mess_inside=400" "tests\17" 17
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=600 -ro=500000000 -special -i=400 -ri=100000000" "tests\18" 18
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=600 -ro=500000000 -special -i=400 -ri=352112676" "tests\19" 19
call scripts\gen-input-via-stdout.bat "files\gen_biggest_ans.exe" "tests\20" 20
call scripts\gen-input-via-stdout.bat "files\gen_random.exe -n=1000 -maxc=20" "tests\21" 21
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=100000 a" "tests\22" 22
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=100000 b" "tests\23" 23
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=100000 c" "tests\24" 24
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=100000 -special" "tests\25" 25
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=100000 -ro=800000000" "tests\26" 26
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=60000 -ro=987654321 -special" "tests\27" 27
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=99990 -mess_inside=10" "tests\28" 28
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=99990 -special -mess_inside=10" "tests\29" 29
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=99990 -ro=823456789 -i=10 -ri=823000000" "tests\30" 30
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=99990 -ro=800000000 -i=10 -ri=790000000" "tests\31" 31
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=99990 -ro=800000000 -mess_inside=10" "tests\32" 32
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=60000 -ro=800000000 -special -mess_inside=10" "tests\33" 33
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=60000 -ro=800000000 -special -i=10 -ri=100000000" "tests\34" 34
call scripts\gen-input-via-stdout.bat "files\gen_line.exe -n=100000" "tests\35" 35
call scripts\gen-input-via-stdout.bat "files\gen_random.exe -n=100000 a" "tests\36" 36
call scripts\gen-input-via-stdout.bat "files\gen_random.exe -n=100000 b" "tests\37" 37
call scripts\gen-input-via-stdout.bat "files\gen_random.exe -n=100000 c" "tests\38" 38
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=90000 -mess_inside=10000" "tests\39" 39
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe -n=90000 -special -mess_inside=10000" "tests\40" 40
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=100000 -ro=500000" "tests\41" 41
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=50000 -ro=823456789 -i=50000 -ri=823000000" "tests\42" 42
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=10000 -ro=800000000 -i=89999 -ri=790000000" "tests\43" 43
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=90000 -ro=800000000 -mess_inside=10000" "tests\44" 44
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=60000 -ro=800000000 -special -mess_inside=40000" "tests\45" 45
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=60000 -ro=800000000 -special -i=40000 -ri=500000000" "tests\46" 46
call scripts\gen-input-via-stdout.bat "files\gen_circle.exe -o=60000 -ro=800000000 -special -i=40000 -ri=563380281" "tests\47" 47
call scripts\gen-input-via-stdout.bat "files\gen_random.exe -n=100000 -maxc=200" "tests\48" 48
call scripts\gen-answer.bat tests\01 tests\01.a "tests" "0"
call scripts\gen-answer.bat tests\02 tests\02.a "tests" "0"
call scripts\gen-answer.bat tests\03 tests\03.a "tests" "0"
call scripts\gen-answer.bat tests\04 tests\04.a "tests" "1"
call scripts\gen-answer.bat tests\05 tests\05.a "tests" "1"
call scripts\gen-answer.bat tests\06 tests\06.a "tests" "1"
call scripts\gen-answer.bat tests\07 tests\07.a "tests" "1"
call scripts\gen-answer.bat tests\08 tests\08.a "tests" "1"
call scripts\gen-answer.bat tests\09 tests\09.a "tests" "1"
call scripts\gen-answer.bat tests\10 tests\10.a "tests" "1"
call scripts\gen-answer.bat tests\11 tests\11.a "tests" "1"
call scripts\gen-answer.bat tests\12 tests\12.a "tests" "1"
call scripts\gen-answer.bat tests\13 tests\13.a "tests" "1"
call scripts\gen-answer.bat tests\14 tests\14.a "tests" "1"
call scripts\gen-answer.bat tests\15 tests\15.a "tests" "1"
call scripts\gen-answer.bat tests\16 tests\16.a "tests" "1"
call scripts\gen-answer.bat tests\17 tests\17.a "tests" "1"
call scripts\gen-answer.bat tests\18 tests\18.a "tests" "1"
call scripts\gen-answer.bat tests\19 tests\19.a "tests" "1"
call scripts\gen-answer.bat tests\20 tests\20.a "tests" "1"
call scripts\gen-answer.bat tests\21 tests\21.a "tests" "1"
call scripts\gen-answer.bat tests\22 tests\22.a "tests" "2"
call scripts\gen-answer.bat tests\23 tests\23.a "tests" "2"
call scripts\gen-answer.bat tests\24 tests\24.a "tests" "2"
call scripts\gen-answer.bat tests\25 tests\25.a "tests" "2"
call scripts\gen-answer.bat tests\26 tests\26.a "tests" "2"
call scripts\gen-answer.bat tests\27 tests\27.a "tests" "2"
call scripts\gen-answer.bat tests\28 tests\28.a "tests" "3"
call scripts\gen-answer.bat tests\29 tests\29.a "tests" "3"
call scripts\gen-answer.bat tests\30 tests\30.a "tests" "3"
call scripts\gen-answer.bat tests\31 tests\31.a "tests" "3"
call scripts\gen-answer.bat tests\32 tests\32.a "tests" "3"
call scripts\gen-answer.bat tests\33 tests\33.a "tests" "3"
call scripts\gen-answer.bat tests\34 tests\34.a "tests" "3"
call scripts\gen-answer.bat tests\35 tests\35.a "tests" "3"
call scripts\gen-answer.bat tests\36 tests\36.a "tests" "4"
call scripts\gen-answer.bat tests\37 tests\37.a "tests" "4"
call scripts\gen-answer.bat tests\38 tests\38.a "tests" "4"
call scripts\gen-answer.bat tests\39 tests\39.a "tests" "4"
call scripts\gen-answer.bat tests\40 tests\40.a "tests" "4"
call scripts\gen-answer.bat tests\41 tests\41.a "tests" "4"
call scripts\gen-answer.bat tests\42 tests\42.a "tests" "4"
call scripts\gen-answer.bat tests\43 tests\43.a "tests" "4"
call scripts\gen-answer.bat tests\44 tests\44.a "tests" "4"
call scripts\gen-answer.bat tests\45 tests\45.a "tests" "4"
call scripts\gen-answer.bat tests\46 tests\46.a "tests" "4"
call scripts\gen-answer.bat tests\47 tests\47.a "tests" "4"
call scripts\gen-answer.bat tests\48 tests\48.a "tests" "4"

