#include "testlib.h"
#include <iostream>

using namespace std;

const int mx = (int)1e9;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int cnt = atoi(argv[2]);
    int mx1 = atoi(argv[3]);
    int mx2 = atoi(argv[4]);
    int p1 = atoi(argv[5]);
    int p2 = atoi(argv[6]);
    vector<pair<int, int>> mas;
    for (int i = 0; i < n; i++) {
    	for (int j = i - 1; j >= 0 && j >= i - 10; j--) {
    		int x = rnd.next(1, p1 + p2);
    		if (x <= p1) {
    			mas.push_back({j + 1, i + 1});
    		}
    	}
    }
    shuffle(mas.begin(), mas.end());
    cout << n << " " << mas.size() << "\n";
    vector<int> arr(n);
    for (int i = 0; i < n; i++) {
    	arr[i] = rnd.next(0, mx1);
    }
    for (int i = 0; i < cnt; i++) {
    	arr[i] = rnd.next(-mx2, -1);
    }
    shuffle(arr.begin(), arr.end());
    for (int i = 0; i < n; i++) {
    	if (i)
    		cout << " ";
    	cout << arr[i];
    }
    cout << "\n";
    for (auto p: mas) {
    	cout << p.first << " " << p.second << "\n";
    }
    return 0;
}