/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define fi first
#define se second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }
 
 
void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> mas(n);
	vector<vector<ll>> dp(2, vector<ll>(1 << 10, INFL));
	vector<vector<int>> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i];
	}
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		arr[b - 1].push_back(a - 1);
	}
	ll ans = 0;
	int k = min(10, n);
	for (int mask = 0; mask < (1 << k); mask++) {
		ll s = 0;
		bool ok = 1;
		for (int i = 0; i < k; i++) {
			if (mask & (1 << i)) {
				s += mas[i];
				for (int j: arr[i]) {
					if (!(mask & (1 << j))) {
						ok = 0;
					}
				} 
			}
		}
		if (ok) {
			dp[0][mask] = s;
			ans = min(ans, s);
		}
	}
	int q = 0;
	for (int i = 0; i + k < n; i++) {
		int w = 1 - q;
		fill(dp[w].begin(), dp[w].end(), INFL);
		int need = 0;
		for (int j: arr[i + k]) {
			need += (1 << (j - i));
		}
		for (int mask = 0; mask < (1 << k); mask++) {
			dp[w][mask / 2] = min(dp[w][mask / 2], dp[q][mask]);
			if ((mask & need) == need) {
				dp[w][mask / 2 + (1 << (k - 1))] = min(dp[w][mask / 2 + (1 << (k - 1))], dp[q][mask] + mas[i + k]);
			}
		}
		for (int mask = 0; mask < (1 << k); mask++) {
			ans = min(ans, dp[w][mask]);
		}
		q = w;
	}
	cout << -ans << endl;
}
 
 
int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}